package nmspack;

import java.net.Socket;
import toolspack.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: </p>
 * @author Stefano Ricciarelli
 * @version 1.0
 */

public class ConnectionListener implements Runnable{

  private int checkTime = 2000;

  public ConnectionListener() {
  }

  //e' synchronized perch per un certo istante possono esserci due thread ConnectionListener
  public synchronized void run() {
    try {
      NMSConfigurator config = NMSConfigurator.getInstance();
      Logger.print(this, "Thread di controllo connessione avviato " );
      while(true) {
        try {
          // config.getSocket().getInputStream(); --> non genera errore se il pari cade
          config.getNms2nmsSocket().sendUrgentData(1);
        } catch (Exception ex) {
          //*************      L'ALTRO NMS  CADUTO     *********************
          Logger.print(this, "ATTENZIONE: impossibile inviare dati urgenti: deduco che la socket  caduta " + ex);
          //sia che sia attivo che passivo devo configurarmi come Alone: ossia chiudo la socket e pongo synch = false
          config.setAlone();
          if (! config.isActive()) {
            //Se sono il NMS passivo devo portarmi nello stato attivo. Prima per devo tentare di ricollegarmi col NMS attivo. Infatti
            //potrebbe essere che la comunicazione sia stata volontariamente interrotta dall'altro NMS perch era scaduto il timeout
            //di un aggiornamento. Allora devo assolutamente evitare che nel sistema siano presenti due NMS attivi contemporaneamente
            //DEVO RIPETERE LA STESSA PROCEDURA DI QUANDO AVVIO NMS:
            Logger.print(this, "NMS passivo:   provo a ricollegarmi al NMS attivo: se non riesco divento io ATTIVO");
            StartNMS s = new StartNMS();
            if ( ! s.tryConnect() ) {
              Logger.print(this, "ERRORE irrimediabile, terminare questo NMS! ");
              return;
            }
            if (config.isActive()) Logger.print(this, "sono diventato NMS ATTIVO ");
            else Logger.print(this, "sono rimasto NMS PASSIVO e ho riaperto una nuova socket con NMS attivo ");
          }//if
          //Termino questo thread poich sono solo oppure perch ne  stato lanciato un altro
          Logger.print(this, "Il thread ConnectionListener termina perch c' un solo NMS oppure perch ne  stato lanciato un altro");
          return;
        }//catch interno
        //Logger.print(this, "La connessione permane ");
        synchronized (this) {
          //altrimenti ricevo l'eccezione java.lang.IllegalMonitorStateException: current thread not owner
          this.wait(checkTime);
        }
      }//while true
    } catch (Exception e) {Logger.print(this, "ERRORE: " + e);}
  }

}//fine classe