package nmspack;

import toolspack.*;
import java.net.*;
import java.io.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: </p>
 * @author Stefano Ricciarelli
 * @version 1.0
 */

public class NMSServerSocket implements Runnable{

  private int MAX_REQ = 1; //al massimo una richiesta alla volta

  public NMSServerSocket() {
  }

  //***************       SONO IL NMS ATTIVO      ***********************///
  //Attendo richieste di connessione da parte di un NMS passivo che si voglia sincronizzare
  //NB: attendo una sola richiesta e se il trasferimento va a buon fine termino!!!!
  public void run() {
    try {
      //boolean notOK = true;
      NMSConfigurator config = NMSConfigurator.getInstance();
      // crea e connette la socket di ascolto
      ServerSocket so = new ServerSocket(config.getNms2nmsTcpPort(), MAX_REQ);
      Logger.print(this, "NMS attivo: socket di ascolto NMS inizializzata sulla porta " + so.getLocalPort());
      Socket newso = null;
      while(true) {
        try {
        // si mette in ascolto. Primitiva bloccante
        newso = so.accept();
        newso.setTcpNoDelay(true);
        newso.setKeepAlive(true);
        newso.setSoTimeout(config.getNms2nmsTimeout());
        boolean ok = true;
        if ( ! config.isActive() ) {
          Logger.print(this, "ATTENZIONE: situazione impossibile: richiesta di connessione pervenuta al NMS passivo: richiesta ignorata ");
          ok = false;
        }
        if ( config.isSync() ) {
          Logger.print(this, "ATTENZIONE: situazione impossibile: richiesta di sincronizzazione pervenuta nello stato synch: richiesta ignorata ");
          ok = false;
        }
        if (ok) {
          Logger.print(this, "NMS attivo: ricevuta richiesta, socket di comunicazione creata");
          //Logger.print(this, "NMS attivo: Impostazione del keepalive " + newso.getKeepAlive());
          config.setCopying(true);
          //non sto ad eseguire un thread come farei di solito! Non ci possono essere altri NMS ad attendere
          ObjectOutputStream oos = new ObjectOutputStream(newso.getOutputStream());
          //Logger.print(this, "NMS attivo: oos aperto");
          oos.writeObject(config.getTableOfAB());
          oos.writeObject(config.getTableOfAID());
          oos.writeObject(config.getTableOfRN());
          oos.writeObject(config.getTableOfWS());
          oos.writeObject(new Integer(config.getRnid()));
          //NB: senza il flush l'altro nodo non funzionava!!!! Evidentemente perch i dati non superano le dimensioni
          //del buffer e quindi non venono mai spediti senza il flush
          oos.flush();
          Logger.print(this, "NMS attivo: dati inviati");
          ObjectInputStream ois = new ObjectInputStream(newso.getInputStream());
          //Logger.print(this, "NMS attivo: ois aperto");
          //String response = ois.readUTF();
          String response = (String)ois.readObject();
          //Logger.print(this, "NMS attivo: La socket  chiusa? " + newso.isClosed());
          if ( response.equalsIgnoreCase("ok") ) {
            Logger.print(this, "NMS Attivo: sincronizzazione della copia passiva effettuata con successo!!!");
            config.setNms2nmsSocket(newso);
            config.setOis(ois);
            config.setOos(oos);
            Logger.print(this, "NMS attivo: Attivo il thread ConnectionListener per controllare che il NMS passivo non cada ");
            Thread t = new Thread( new ConnectionListener() );
            t.start();
            config.setSynch(true);
            config.setCopying(false);
            Logger.print(this, "NMS attivo: il serverSocket ha sincronizzato un NMS passivo. ");
            //NOOOO so.close();
            //notOK = false;
          } else {
            Logger.print(this, "NMS attivo: Trasferimento dati non confermato dall'altro NMS - continuo a lavorare solo");
            try{newso.close();}catch (Exception e2){}
            config.setSynch(false);
            config.setCopying(false);
          }//else
        }//if ok
        } catch (Exception ex) {
          //si  avuto un errore durante la copia dei dati oppure  scaduto il timeout. Ignoro l'accaduto e ciclo in attesa di nuove richieste
          Logger.print(this, "NMS attivo: ATTENZIONE: errore trasferendo i dati al NMS passivo o timeout scaduto - ignoro e continuo a lavorare solo" + ex);
          try{newso.close();}catch (Exception e2){}
          config.setSynch(false);
          config.setCopying(false);
        }//catch interno
      }//while true
    } catch (Exception e) {
      Logger.print(this, "NMS attivo: ERRORE FATALE: serverSocket terminato - TERMINARE QUESTO NMS " + e);
      return;
    }//catch esterno
    //Logger.print(this, "NMS attivo: ERRORE FATALE: serverSocket terminato - TERMINARE QUESTO NMS");
  }


}//fine classe