package nmspack;

import toolspack.*;
import java.io.*;
import java.util.*;
import java.net.*;


/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: </p>
 * @author Stefano Ricciarelli
 * @version 1.0
 */

public class SynchronizingThread implements Runnable{

  public SynchronizingThread() {
  }

  /**
   * Nota che questo NMS potrebbe essere stato prima passivo, e per questo  stato creato questo thread, e poi essere
   * diventato attivo. In tal caso succede che la ois.readInt fallisce e questo consente, correttamente, di fare terminare
   * questo thread che non ha ragione di esistere se il NMS  attivo. Si noti che un NMS attivo non pu mai diventare
   * passivo ma solo terminare.
   */
  public void run() {
    NMSConfigurator config = NMSConfigurator.getInstance();
    ObjectInputStream  ois = config.getOis();
    ObjectOutputStream oos = config.getOos();

    while (true) {
      try {
        Logger.print(this, "Sono in ascolto di operazioni di sincronizzazione ");
        //Logger.print(this, "ois chiuso? " + ois.ii);
        int opCode = ((Integer)ois.readObject()).intValue(); //ois.readInt();
        //if (opCode == -1) Logger.print(this, "ERRORE:::::: ho letto -1 ");
        Logger.print(this, "lettura opcode OK = " + opCode);
        if (opCode == 1) {
            //copia di TableOfAB
            Logger.print(this, "NMS passivo: copio TableOfAB dal NMS attivo ");
            //config.getNms2nmsSocket().setSoTimeout(config.getNms2nmsTimeout());
            config.setTableOfAB ((Map)ois.readObject());
            //config.getNms2nmsSocket().setSoTimeout(0); //nessun timeout
            oos.writeObject(new Boolean(true));
            //oos.writeBoolean(true);
            oos.flush();
            Logger.print(this, "NMS passivo: copia effettuata, 'true' spedito a conferma ");
          }
        if (opCode == 2) {
            //copia di TableOfAID
            Logger.print(this, "NMS passivo: copio TableOfAID dal NMS attivo ");
            //config.getNms2nmsSocket().setSoTimeout(config.getNms2nmsTimeout());
            config.setTableOfAID ((Map)ois.readObject());
            //config.getNms2nmsSocket().setSoTimeout(0); //nessun timeout
            oos.writeObject(new Boolean(true));
            oos.flush();
            Logger.print(this, "NMS passivo: copia effettuata, 'true' spedito a conferma ");
          }
        if (opCode == 3) {
            //copia di setTableOfRN
            Logger.print(this, "NMS passivo: copio setTableOfRN dal NMS attivo ");
            //config.getNms2nmsSocket().setSoTimeout(config.getNms2nmsTimeout());
            config.setTableOfRN ((Map)ois.readObject());
            //config.getNms2nmsSocket().setSoTimeout(0); //nessun timeout
            oos.writeObject(new Boolean(true));
            oos.flush();
            Logger.print(this, "NMS passivo: copia effettuata, 'true' spedito a conferma ");
          }
        if (opCode == 4) {
            //copia di TableOfWS
            Logger.print(this, "NMS passivo: copio TableOfWS dal NMS attivo ");
            //config.getNms2nmsSocket().setSoTimeout(config.getNms2nmsTimeout());
            config.setTableOfWS ((Map)ois.readObject());
            //config.getNms2nmsSocket().setSoTimeout(0); //nessun timeout
            oos.writeObject(new Boolean(true));
            oos.flush();
            Logger.print(this, "NMS passivo: copia effettuata, 'true' spedito a conferma ");
          }
        if (opCode == 5) {
            //copia di rnid
            Logger.print(this, "NMS passivo: copio rnid dal NMS attivo ");
            //config.getNms2nmsSocket().setSoTimeout(config.getNms2nmsTimeout());
            //config.setRnid ( ois.readInt() );
            config.setRnid( Integer.parseInt( (String)ois.readObject() )  );
            //config.getNms2nmsSocket().setSoTimeout(0); //nessun timeout
            oos.writeObject(new Boolean(true));
            oos.flush();
            Logger.print(this, "NMS passivo: copia effettuata, 'true' spedito a conferma ");
          }
        if ( (opCode < 1 ) || (opCode > 5) ) {
            Logger.print(this, "Comando sconosciuto (" + opCode + "). Comando ignorato");
          }
     }
/*     catch (SocketTimeoutException ex1) {
       Logger.print(this, new Date(System.currentTimeMillis()) + "timeout scaduto, ciclo nuovamente. Riprovo: ");
       try {
         ois.readInt();
       } catch (Exception ex) {
         Logger.print(this, new Date(System.currentTimeMillis()) + "ERRORE NEL Ritentare!!! C' qualcosa che non va in ois ");
       }
     }//catch
     catch (EOFException ex2) {
       Logger.print(this, "ricevuto " + ex2 + ", ciclo nuovamente ");
     }//catch */
     catch (Exception ex3) {
       Logger.print(this, "ATTENZIONE la sincronizzazione  fallita " + ex3 + " mi disconetto chiamando SetAlone e termino questo thread");
       config.setAlone();
       return;
     }//catch
   }//while true
  }



}//fine classe