package nmspack.udpservices;

import toolspack.udppack.IService;
import toolspack.udppack.IServiceEndPoint;
import java.io.*;
import toolspack.*;
import nmspack.*;
import java.util.Random;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: </p>
 * @author Stefano Ricciarelli
 * @version 1.0
 */

public class GetRNService implements IService {


  private IServiceEndPoint sep;
  private byte[] request;
  private NMSConfigurator config;

  public GetRNService() {
    config = NMSConfigurator.getInstance();
  }
  public void setServiceEndPoint(IServiceEndPoint sep) {
    this.sep = sep;
  }
  public void setRequest(byte[] request) {
    this.request = request;
  }
  public void run() {
    //ESECUZIONE one-shot. Finite le operazioni per questa richiesta termino.
    //Successive richieste genereranno altri thread.
    if (config.isCopying() || !config.isActive()) {
      Logger.print(this, "Richiesta ignorata - questo NMS  passivo oppure  in fase di copia" );
      return;
    }
    try {
      DataInputStream din = new DataInputStream( new ByteArrayInputStream(request) );
      Logger.print(this, " ***** Servizio GetRN ");
      int wsid = din.readInt();
      int aid  = config.getAIDofWSID(wsid);
      if (aid < 0 ) {
        error("Nessuna applicazione mappata sul WS " + wsid);
        return;
      }
      Address a = choiceRn(aid);
      if (a == null) {
        error("Nessun RN disponibile all'esecuzione ");
        return;
      }
      ByteArrayOutputStream b = new ByteArrayOutputStream();
      DataOutputStream dos = new DataOutputStream(b);
      dos.write(a.getSerializedForm());
      dos.writeInt(aid);
      dos.close();
      sep.send(b.toByteArray());
      Logger.print(this, "Ho restituito il rn di indirizzo " + a);
    } catch (Exception ex) {
      Logger.print(this, "ERRORE in GetRN " + ex);
      return;
    }//catch
  }

  private Address choiceRn(int aid) {
    Address[] addrs = config.getRegisteredRnForAid(aid);
    int length = addrs.length;
    if (length <= 0) return null;
    int counter = config.getNewStaticCounterValue();
    if (counter >= (length - 1) ) {
      counter = length - 1;
      config.resetStaticCounterValue();
    }
    //int random = (new Random(System.currentTimeMillis())).nextInt(length - 1);
    Logger.print(this, "Assegno un RN per questa applicazione fra 0 e " + (length - 1) + " (compresi) = " + counter);
    return addrs[counter];
  }

  private void error(String s) {
    Logger.print(this, s);
    try {
      sep.send(ByteUtil.toByteArray((short) -1));
    } catch (Exception ex) {
      Logger.print(this, "ERRORE spedento il valore di errore di ritorno");
    }
  }


}//fine classe