package nmspack.udpservices;


import toolspack.udppack.IService;
import toolspack.udppack.IServiceEndPoint;
import java.io.*;
import toolspack.*;
import nmspack.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: </p>
 * @author Stefano Ricciarelli
 * @version 1.0
 */

public class LookupABService implements IService {


  private IServiceEndPoint sep;
  private byte[] request;
  private NMSConfigurator config;

  public LookupABService() {
    config = NMSConfigurator.getInstance();
  }
  public void setServiceEndPoint(IServiceEndPoint sep) {
    this.sep = sep;
  }
  public void setRequest(byte[] request) {
    this.request = request;
  }
  public void run() {
    //ESECUZIONE one-shot. Finite le operazioni per questa richiesta termino.
    //Successive richieste genereranno altri thread.
    if (config.isCopying() || !config.isActive()) {
      Logger.print(this, "Richiesta ignorata - questo NMS  passivo oppure  in fase di copia" );
      return;
    }
    try {
      DataInputStream din = new DataInputStream( new ByteArrayInputStream(request) );
      Logger.print(this, " ***** Servizio LookupAB ");
      String abName = din.readUTF();
      Address addr = config.lookupAB(abName);
      //Logger.print(this, "Servizio LookupAB 2");
      if (addr == null) {
        Logger.print(this, "AB richiesto non trovato: " + abName);
        sep.send(ByteUtil.toByteArray((short) -1));
      }
      sep.send(addr.getSerializedForm());
      Logger.print(this, "AB trovato, indirizzo spedito");
    } catch (Exception ex) {
      Logger.print(this, "ERRORE in LookupAB " + ex);
      return;
    }//catch
  }



}//fine classe