package nmspack.udpservices;

import toolspack.udppack.IService;
import toolspack.udppack.IServiceEndPoint;
import java.io.*;
import toolspack.*;
import nmspack.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: </p>
 * @author Stefano Ricciarelli
 * @version 1.0
 */

public class RegisterRNService implements IService {


  private IServiceEndPoint sep;
  private byte[] request;
  private NMSConfigurator config;

  public RegisterRNService() {
    config = NMSConfigurator.getInstance();
  }
  public void setServiceEndPoint(IServiceEndPoint sep) {
    this.sep = sep;
  }
  public void setRequest(byte[] request) {
    this.request = request;
  }
  public void run() {
    //PROTOCOLLO RETI numero ** 2 ** - REGISTRAZIONE PRESSO NMS DEL RN
    //ESECUZIONE one-shot. Finite le operazioni per questa richiesta termino.
    //Successive richieste genereranno altri thread.
    if (config.isCopying() || !config.isActive()) {
      Logger.print(this, "Richiesta ignorata - questo NMS  passivo oppure  in fase di copia" );
      return;
    }
    try {
      DataInputStream din = new DataInputStream( new ByteArrayInputStream(request) );
      Logger.print(this, " ***** Servizio RegisterRN ");
      short iplength = din.readShort();
      byte[] ipraw   = new byte[iplength];
                       din.read(ipraw, 0, iplength);
      int port       = din.readInt();
      Address addr   = new Address(ipraw, port);
      int rnid       = config.getRnidFromRnAddress(addr); //cerco se per caso  gi stato registrato questo RN
      if (rnid != -1) {
        Logger.print(this, "Il RN era gi stato registrato in precedenza, spedisco lo rnid assegnatogli a suo tempo");
        sep.send(ByteUtil.toByteArray(rnid));
      } else {
        rnid = config.getNewRnid();
        config.addRN(rnid, addr);
        Logger.print(this, "registrazione del nuovo RN effettuata, spedisco rnid sul sep");
        sep.send(ByteUtil.toByteArray(rnid));
      }//else
    } catch (Exception ex) {
      Logger.print(this, "ERRORE in registerRN " + ex);
      return;
    }//catch
  }



}//fine classe