package nmspack.udpservices;

import toolspack.udppack.IService;
import toolspack.udppack.IServiceEndPoint;
import java.io.*;
import toolspack.*;
import nmspack.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: </p>
 * @author Stefano Ricciarelli
 * @version 1.0
 */

public class RegisterWSService implements IService {


  private IServiceEndPoint sep;
  private byte[] request;
  private NMSConfigurator config;

  public RegisterWSService() {
    config = NMSConfigurator.getInstance();
  }
  public void setServiceEndPoint(IServiceEndPoint sep) {
    this.sep = sep;
  }
  public void setRequest(byte[] request) {
    this.request = request;
  }
  public void run() {
    //PROTOCOLLO RETI numero ** 1 ** - REGISTRAZIONE PRESSO NMS DEL RN
    //ESECUZIONE one-shot. Finite le operazioni per questa richiesta termino.
    //Successive richieste genereranno altri thread.
    if (config.isCopying() || !config.isActive()) {
      Logger.print(this, "Richiesta ignorata - questo NMS  passivo oppure  in fase di copia" );
      return;
    }
    try {
      DataInputStream din = new DataInputStream( new ByteArrayInputStream(request) );
      Logger.print(this, " ***** Servizio RegisterWS ");
      int wsid      = din.readInt();
      config.addWS(wsid);
      Logger.print(this, "registrazione WS effettuata, spedisco 'ok' sul sep");
      ByteArrayOutputStream b = new ByteArrayOutputStream();
      DataOutputStream dos = new DataOutputStream(b);
      dos.writeUTF("ok");
      dos.close();
      sep.send(b.toByteArray());
    } catch (Exception ex) {
      Logger.print(this, "ERRORE in RegisterWS " + ex);
      return;
    }//catch
  }


}//fine classe